
# line 2 "grammar.y"
/* 
 * Copyright 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996,
 * 1997, 2001, 2004. The Regents of the University of California 
 * (Regents). All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for educational, research, and not-for-profit purposes,
 * without fee and without a signed licensing agreement, is hereby
 * granted, provided that the above copyright notice, this paragraph and
 * the following three paragraphs appear in all copies, modifications, and
 * distributions. Contact The Office of Technology Licensing, UC
 * Berkeley, 2150 Shattuck Avenue, Suite 510, Berkeley, CA 94720-1620,
 * (510) 643-7201, for commercial licensing opportunities. 
 *
 * This code is derived from the Stanford/CMU enet packet filter,
 * distributed as part of 4.3BSD, and code contributed to Berkeley by
 * Steven McCanne and Van Jacobson both of Lawrence Berkeley Laboratory,
 * and Andrew Begel of the Berkeley Computer Science Division of the
 * Electrical Engineering and Computer Science Department.
 * 
 * IN NO EVENT SHALL REGENTS BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 * REGENTS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING DOCUMENTATION, IF
 * ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS".  REGENTS HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 */
#ifndef lint
static char rcsid[] =
    "@(#) $Header: /usr/src/mash/repository/bpfl/grammar.y,v 1.2 1997/11/18 00:09:46 mccanne Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>

#include <net/if.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>

#include <stdio.h>
#include <pcap-namedb.h>

#include "gencode.h"

#define QSET(q, p, d, a) (q).proto = (p),\
			 (q).dir = (d),\
			 (q).addr = (a)

int n_errors = 0;

static struct qual qerr = { Q_UNDEF, Q_UNDEF, Q_UNDEF, Q_UNDEF };

static void
yyerror(char *msg)
{
	++n_errors;
	bpf_error(msg);
	/* NOTREACHED */
}

#ifndef YYBISON
int
bpfl_parse()
{
	return (yyparse());
}
#endif


# line 68 "grammar.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
	int i;
	u_long h;
	u_char *e;
	char *s;
	struct stmt *stmt;
	struct arth *a;
	struct {
		struct qual q;
		struct block *b;
	} blk;
	struct block *rblk;
} YYSTYPE;
# define DST 257
# define SRC 258
# define HOST 259
# define GATEWAY 260
# define NET 261
# define MASK 262
# define PORT 263
# define LESS 264
# define GREATER 265
# define PROTO 266
# define BYTE 267
# define ARP 268
# define RARP 269
# define IP 270
# define TCP 271
# define UDP 272
# define ICMP 273
# define IGMP 274
# define IGRP 275
# define ATALK 276
# define DECNET 277
# define LAT 278
# define SCA 279
# define MOPRC 280
# define MOPDL 281
# define TK_BROADCAST 282
# define TK_MULTICAST 283
# define NUM 284
# define INBOUND 285
# define OUTBOUND 286
# define LINK 287
# define GEQ 288
# define LEQ 289
# define NEQ 290
# define ID 291
# define EID 292
# define HID 293
# define LSH 294
# define RSH 295
# define LEN 296
# define EVERY 297
# define OR 298
# define AND 299
# define UMINUS 300

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 271 "grammar.y"

static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	0, 2,
	-2, 44,
-1, 11,
	0, 39,
	298, 39,
	299, 39,
	41, 39,
	-2, 43,
-1, 42,
	0, 5,
	298, 5,
	299, 5,
	41, 5,
	-2, 44,
-1, 93,
	0, 15,
	298, 15,
	299, 15,
	41, 15,
	-2, 79,
-1, 134,
	298, 28,
	299, 28,
	-2, 79,
-1, 135,
	288, 91,
	289, 91,
	290, 91,
	42, 91,
	47, 91,
	62, 91,
	61, 91,
	60, 91,
	-2, 84,
	};
# define YYNPROD 101
# define YYLAST 534
static const yytabelem yyact[]={

    14,   109,    41,    40,   141,    64,    16,    16,   151,    62,
    60,   148,    98,   140,    63,   126,   127,   124,   125,    88,
    64,    87,    86,   147,    62,    60,    82,    61,    83,    63,
    84,   106,   146,    64,    14,   145,   144,    62,    60,   152,
    61,    16,    63,    39,    38,    57,    36,    75,   111,   136,
   110,    29,    13,   143,    64,   129,     1,    47,    62,    60,
   108,    61,    55,    63,    62,    60,     2,    61,    14,    63,
    46,    62,    60,     6,    61,    16,    63,   131,   133,   132,
    36,     5,    45,    81,    80,    82,    85,    83,   142,    84,
    54,    65,    76,     3,    59,    55,    14,    62,    14,    91,
    96,    58,    63,    16,   128,    16,    65,   103,    78,    79,
    36,    77,    90,    95,    74,    15,     9,   104,    43,    65,
     7,    10,   123,   101,    97,     0,     0,    10,    49,    10,
     0,     0,    14,    99,     0,     0,     0,     0,     0,    16,
     0,   130,    12,     0,    36,     0,    55,    42,   138,   137,
     0,     0,   103,     0,     0,     0,     0,    94,    94,    16,
     0,    10,     0,     0,    36,     0,    45,     0,   105,    64,
     0,     0,    49,    62,    60,     0,    61,     0,    63,    89,
     0,     0,     0,     0,     0,     0,   100,     0,     0,     0,
     0,    72,    70,    68,     0,     0,     0,     0,   149,   150,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,    94,     0,    10,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
     0,    30,    31,     0,    32,    19,    20,    18,    21,    22,
    23,   135,     0,     0,    24,    25,   107,    27,    26,     0,
    35,    35,    33,    34,    17,    65,    49,    49,    41,    40,
     0,    66,    67,    37,     4,    30,    31,     0,    32,    19,
    20,    18,    21,    22,    23,     0,    66,    67,    24,    25,
     0,    27,    26,     0,     0,    35,    33,    34,    17,    66,
    67,     0,    50,    52,    51,     0,     0,    37,     4,    30,
    31,     0,    32,    19,    20,    18,    21,    22,    23,     0,
    66,    67,    24,    25,     0,    27,    26,     0,     0,    35,
    33,    34,    17,    66,    67,     0,    50,    52,    51,    30,
    31,    37,    32,    19,    20,    18,    21,    22,    23,     0,
     0,     0,    24,    25,     0,    27,    26,    35,     0,    35,
    33,    34,    17,     0,    50,    52,    51,     0,     0,     0,
     0,    37,     4,    30,    31,     0,    32,    19,    20,    18,
    21,    22,    23,     0,     0,     0,    24,    25,     0,    27,
    26,     0,     0,    35,    33,    34,    17,    19,    20,    18,
    21,    22,    23,     0,    28,    37,    24,    25,     0,    27,
    26,     0,     0,    35,    48,    56,    17,     0,     0,     0,
     0,     0,     0,    53,     0,    37,     8,     0,     0,    69,
    71,    73,     8,     0,     8,    66,    67,     0,    44,     0,
     0,    11,     0,    93,    93,     0,     0,    11,    56,    11,
     0,     0,     0,     0,   102,     0,     0,     0,    48,     0,
     0,     0,    92,    92,     0,     0,     8,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    11,    11,     0,
     0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    93,     0,   134,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   139,     0,     0,     0,     0,     0,    92,     0,    92,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    11,     0,    11,     0,     0,     0,     0,     0,     0,
     0,     0,    48,    48 };
static const yytabelem yypact[]={

-10000000,-10000000,    65,  -296,   119,-10000000,-10000000,-10000000,    99,    63,
    65,   -46,   131,-10000000,-10000000,  -174,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
  -262,  -263,  -265,-10000000,-10000000,-10000000,   119,-10000000,    35,    35,
-10000000,-10000000,   -33,   119,   -46,-10000000,-10000000,-10000000,-10000000,    63,
-10000000,   -16,-10000000,    63,   -40,     9,     7,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -233,-10000000,-10000000,-10000000,-10000000,-10000000,
  -281,  -283,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,    17,-10000000,
-10000000,-10000000,    35,-10000000,     1,-10000000,-10000000,-10000000,   119,  -296,
   -18,     8,     7,-10000000,  -296,   -34,  -271,  -289,-10000000,-10000000,
-10000000,-10000000,    -5,   -18,   -18,    55,    55,-10000000,-10000000,    29,
    16,    22,    22,-10000000,  -221,  -222,  -226,  -235,  -273,-10000000,
-10000000,-10000000,-10000000,-10000000,     7,-10000000,-10000000,    63,    63,     7,
-10000000,-10000000,-10000000,  -276,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,   -54,-10000000 };
static const yytabelem yypgo[]={

     0,    90,    81,    60,    57,   123,    73,   120,   117,   116,
   115,   114,    47,   111,   142,    51,   104,   428,   394,   101,
    94,    44,    43,   118,   413,    66,    56,    52 };
static const yytabelem yyr1[]={

     0,    26,    26,    25,     1,     1,     1,     2,     2,     2,
     2,     2,    21,    22,     3,     3,     3,     4,     4,     4,
     4,     4,     4,    24,    23,     5,     5,     5,     8,     8,
     6,     6,     9,     9,     9,     9,     9,     7,     7,     7,
     7,     7,     7,    10,    10,    11,    11,    11,    11,    11,
    11,    12,    12,    12,    13,    17,    17,    17,    17,    17,
    17,    17,    17,    17,    17,    17,    27,    27,    27,    27,
    27,    27,    27,    19,    19,    19,    20,    20,    20,    14,
    14,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    16,    16,    16,    16,    16,    18,
    18 };
static const yytabelem yyr2[]={

     0,     5,     2,     1,     7,     5,     2,     2,     7,     7,
     7,     7,     3,     3,     2,     3,     7,     3,     7,     7,
     3,     3,     5,     3,     3,     2,     7,     7,     3,     2,
     2,     5,     7,     5,     5,     5,     5,     5,     7,     3,
     7,     7,     3,     2,     1,     3,     3,     7,     7,     7,
     7,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     5,     5,     5,     5,
     9,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     2,     9,    13,     7,     7,     7,     7,     7,     7,     7,
     7,     5,     7,     3,     3,     3,     3,     3,     3,     2,
     7 };
static const yytabelem yychk[]={

-10000000,   -26,   -25,    -1,   297,    -2,    -6,    -7,   -24,    -9,
   -23,   -17,   -14,   -27,    33,   -10,    40,   287,   270,   268,
   269,   271,   272,   273,   277,   278,   281,   280,   -18,   -15,
   264,   265,   267,   285,   286,   284,    45,   296,   -21,   -22,
   299,   298,   -14,   -23,   -17,    -6,    -3,    -4,   -18,   -23,
   291,   293,   292,   -24,    -1,   -15,   -18,    91,   -19,   -20,
    43,    45,    42,    47,    38,   124,   294,   295,    62,   288,
    61,   289,    60,   290,   -11,   -12,   266,   -13,   282,   283,
   258,   257,   259,   261,   263,   260,   284,   284,   284,   -14,
    -6,    -3,   -24,   -18,   -23,    -6,    -3,    -2,    45,    -1,
   -14,    -5,   -18,    -4,    -8,   -23,    47,   262,    -3,    41,
    41,    41,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
   -14,   -14,   -14,   -12,   298,   299,   298,   299,   -16,    38,
   124,    60,    62,    61,   -18,   -14,    41,   -21,   -22,   -18,
   284,   293,    93,    58,   257,   257,   258,   258,   284,    -3,
    -3,   284,    93 };
static const yytabelem yydef[]={

     3,    -2,    -2,     1,     0,     6,     7,    30,    44,     0,
    44,    -2,     0,    42,    23,     0,    24,    55,    56,    57,
    58,    59,    60,    61,    62,    63,    64,    65,    79,    80,
     0,     0,     0,    71,    72,    99,     0,    93,    44,    44,
    12,    13,    -2,     0,     0,    31,    37,    14,    15,     0,
    17,    20,    21,     0,     0,    80,    79,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    73,    74,
    75,    76,    77,    78,    33,    34,    35,    36,    66,    67,
    45,    46,    51,    52,    53,    54,    68,    69,     0,    91,
     8,     9,    44,    -2,    44,    10,    11,     4,     0,     0,
     0,    29,    28,    25,     0,     0,     0,     0,    22,    38,
    92,   100,     0,    40,    41,    83,    84,    85,    86,    87,
    88,    89,    90,    32,     0,     0,     0,     0,     0,    94,
    95,    96,    97,    98,    -2,    -2,    16,     0,     0,     0,
    18,    19,    81,     0,    47,    49,    48,    50,    70,    26,
    27,     0,    82 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"DST",	257,
	"SRC",	258,
	"HOST",	259,
	"GATEWAY",	260,
	"NET",	261,
	"MASK",	262,
	"PORT",	263,
	"LESS",	264,
	"GREATER",	265,
	"PROTO",	266,
	"BYTE",	267,
	"ARP",	268,
	"RARP",	269,
	"IP",	270,
	"TCP",	271,
	"UDP",	272,
	"ICMP",	273,
	"IGMP",	274,
	"IGRP",	275,
	"ATALK",	276,
	"DECNET",	277,
	"LAT",	278,
	"SCA",	279,
	"MOPRC",	280,
	"MOPDL",	281,
	"TK_BROADCAST",	282,
	"TK_MULTICAST",	283,
	"NUM",	284,
	"INBOUND",	285,
	"OUTBOUND",	286,
	"LINK",	287,
	"GEQ",	288,
	"LEQ",	289,
	"NEQ",	290,
	"ID",	291,
	"EID",	292,
	"HID",	293,
	"LSH",	294,
	"RSH",	295,
	"LEN",	296,
	"EVERY",	297,
	"OR",	298,
	"AND",	299,
	"!",	33,
	"|",	124,
	"&",	38,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"UMINUS",	300,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"prog : null expr",
	"prog : null",
	"null : /* empty */",
	"expr : EVERY arth expr1",
	"expr : EVERY arth",
	"expr : expr1",
	"expr1 : term",
	"expr1 : expr and term",
	"expr1 : expr and id",
	"expr1 : expr or term",
	"expr1 : expr or id",
	"and : AND",
	"or : OR",
	"id : nid",
	"id : pnum",
	"id : paren pid ')'",
	"nid : ID",
	"nid : HID '/' NUM",
	"nid : HID MASK HID",
	"nid : HID",
	"nid : EID",
	"nid : not id",
	"not : '!'",
	"paren : '('",
	"pid : nid",
	"pid : qid and id",
	"pid : qid or id",
	"qid : pnum",
	"qid : pid",
	"term : rterm",
	"term : not term",
	"head : pqual dqual aqual",
	"head : pqual dqual",
	"head : pqual aqual",
	"head : pqual PROTO",
	"head : pqual ndaqual",
	"rterm : head id",
	"rterm : paren expr ')'",
	"rterm : pname",
	"rterm : arth relop arth",
	"rterm : arth irelop arth",
	"rterm : other",
	"pqual : pname",
	"pqual : /* empty */",
	"dqual : SRC",
	"dqual : DST",
	"dqual : SRC OR DST",
	"dqual : DST OR SRC",
	"dqual : SRC AND DST",
	"dqual : DST AND SRC",
	"aqual : HOST",
	"aqual : NET",
	"aqual : PORT",
	"ndaqual : GATEWAY",
	"pname : LINK",
	"pname : IP",
	"pname : ARP",
	"pname : RARP",
	"pname : TCP",
	"pname : UDP",
	"pname : ICMP",
	"pname : DECNET",
	"pname : LAT",
	"pname : MOPDL",
	"pname : MOPRC",
	"other : pqual TK_BROADCAST",
	"other : pqual TK_MULTICAST",
	"other : LESS NUM",
	"other : GREATER NUM",
	"other : BYTE NUM byteop NUM",
	"other : INBOUND",
	"other : OUTBOUND",
	"relop : '>'",
	"relop : GEQ",
	"relop : '='",
	"irelop : LEQ",
	"irelop : '<'",
	"irelop : NEQ",
	"arth : pnum",
	"arth : narth",
	"narth : pname '[' arth ']'",
	"narth : pname '[' arth ':' NUM ']'",
	"narth : arth '+' arth",
	"narth : arth '-' arth",
	"narth : arth '*' arth",
	"narth : arth '/' arth",
	"narth : arth '&' arth",
	"narth : arth '|' arth",
	"narth : arth LSH arth",
	"narth : arth RSH arth",
	"narth : '-' arth",
	"narth : paren narth ')'",
	"narth : LEN",
	"byteop : '&'",
	"byteop : '|'",
	"byteop : '<'",
	"byteop : '>'",
	"byteop : '='",
	"pnum : NUM",
	"pnum : paren pnum ')'",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.14	97/01/16 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 118 "grammar.y"
{
	finish_parse(yypvt[-0].blk.b);
} break;
case 3:
# line 123 "grammar.y"
{ yyval.blk.q = qerr; } break;
case 4:
# line 126 "grammar.y"
{ yyval.blk.b = gen_every(yypvt[-1].a); yyval.blk.q = qerr; 
	                          gen_and(yypvt[-0].blk.b, yyval.blk.b); } break;
case 5:
# line 128 "grammar.y"
{ yyval.blk.b = gen_every(yypvt[-0].a); yyval.blk.q = qerr; } break;
case 8:
# line 132 "grammar.y"
{ gen_and(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 9:
# line 133 "grammar.y"
{ gen_and(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 10:
# line 134 "grammar.y"
{ gen_or(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 11:
# line 135 "grammar.y"
{ gen_or(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 12:
# line 138 "grammar.y"
{ yyval.blk = yypvt[-1].blk; } break;
case 13:
# line 140 "grammar.y"
{ yyval.blk = yypvt[-1].blk; } break;
case 15:
# line 143 "grammar.y"
{ yyval.blk.b = gen_ncode((const char *)NULL, (u_long)yypvt[-0].i,
						   yyval.blk.q = yypvt[-1].blk.q); } break;
case 16:
# line 145 "grammar.y"
{ yyval.blk = yypvt[-1].blk; } break;
case 17:
# line 147 "grammar.y"
{ yyval.blk.b = gen_scode(yypvt[-0].s, yyval.blk.q = yypvt[-1].blk.q); } break;
case 18:
# line 148 "grammar.y"
{ yyval.blk.b = gen_mcode((const char *)yypvt[-2].h, NULL, yypvt[-0].i,
				    yyval.blk.q = yypvt[-3].blk.q); } break;
case 19:
# line 150 "grammar.y"
{ yyval.blk.b = gen_mcode((const char *)yypvt[-2].h, (const char *)yypvt[-0].h, 0,
				    yyval.blk.q = yypvt[-3].blk.q); } break;
case 20:
# line 152 "grammar.y"
{
				  /* Decide how to parse HID based on proto */
				  yyval.blk.q = yypvt[-1].blk.q;
				  switch (yyval.blk.q.proto) {
				  case Q_DECNET:
					yyval.blk.b = gen_ncode((const char *)yypvt[-0].h, 0, yyval.blk.q);
					break;
				  default:
					yyval.blk.b = gen_ncode((const char *)yypvt[-0].h, 0, yyval.blk.q);
					break;
				  }
				} break;
case 21:
# line 164 "grammar.y"
{ yyval.blk.b = gen_ecode(yypvt[-0].e, yyval.blk.q = yypvt[-1].blk.q); } break;
case 22:
# line 165 "grammar.y"
{ gen_not(yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 23:
# line 167 "grammar.y"
{ yyval.blk = yypvt[-1].blk; } break;
case 24:
# line 169 "grammar.y"
{ yyval.blk = yypvt[-1].blk; } break;
case 26:
# line 172 "grammar.y"
{ gen_and(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 27:
# line 173 "grammar.y"
{ gen_or(yypvt[-2].blk.b, yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 28:
# line 175 "grammar.y"
{ yyval.blk.b = gen_ncode(NULL, (u_long)yypvt[-0].i,
						   yyval.blk.q = yypvt[-1].blk.q); } break;
case 31:
# line 180 "grammar.y"
{ gen_not(yypvt[-0].blk.b); yyval.blk = yypvt[-0].blk; } break;
case 32:
# line 182 "grammar.y"
{ QSET(yyval.blk.q, yypvt[-2].i, yypvt[-1].i, yypvt[-0].i); } break;
case 33:
# line 183 "grammar.y"
{ QSET(yyval.blk.q, yypvt[-1].i, yypvt[-0].i, Q_DEFAULT); } break;
case 34:
# line 184 "grammar.y"
{ QSET(yyval.blk.q, yypvt[-1].i, Q_DEFAULT, yypvt[-0].i); } break;
case 35:
# line 185 "grammar.y"
{ QSET(yyval.blk.q, yypvt[-1].i, Q_DEFAULT, Q_PROTO); } break;
case 36:
# line 186 "grammar.y"
{ QSET(yyval.blk.q, yypvt[-1].i, Q_DEFAULT, yypvt[-0].i); } break;
case 37:
# line 188 "grammar.y"
{ yyval.blk = yypvt[-0].blk; } break;
case 38:
# line 189 "grammar.y"
{ yyval.blk.b = yypvt[-1].blk.b; yyval.blk.q = yypvt[-2].blk.q; } break;
case 39:
# line 190 "grammar.y"
{ yyval.blk.b = gen_proto_abbrev(yypvt[-0].i); yyval.blk.q = qerr; } break;
case 40:
# line 191 "grammar.y"
{ yyval.blk.b = gen_relation(yypvt[-1].i, yypvt[-2].a, yypvt[-0].a, 0);
				  yyval.blk.q = qerr; } break;
case 41:
# line 193 "grammar.y"
{ yyval.blk.b = gen_relation(yypvt[-1].i, yypvt[-2].a, yypvt[-0].a, 1);
				  yyval.blk.q = qerr; } break;
case 42:
# line 195 "grammar.y"
{ yyval.blk.b = yypvt[-0].rblk; yyval.blk.q = qerr; } break;
case 44:
# line 199 "grammar.y"
{ yyval.i = Q_DEFAULT; } break;
case 45:
# line 202 "grammar.y"
{ yyval.i = Q_SRC; } break;
case 46:
# line 203 "grammar.y"
{ yyval.i = Q_DST; } break;
case 47:
# line 204 "grammar.y"
{ yyval.i = Q_OR; } break;
case 48:
# line 205 "grammar.y"
{ yyval.i = Q_OR; } break;
case 49:
# line 206 "grammar.y"
{ yyval.i = Q_AND; } break;
case 50:
# line 207 "grammar.y"
{ yyval.i = Q_AND; } break;
case 51:
# line 210 "grammar.y"
{ yyval.i = Q_HOST; } break;
case 52:
# line 211 "grammar.y"
{ yyval.i = Q_NET; } break;
case 53:
# line 212 "grammar.y"
{ yyval.i = Q_PORT; } break;
case 54:
# line 215 "grammar.y"
{ yyval.i = Q_GATEWAY; } break;
case 55:
# line 217 "grammar.y"
{ yyval.i = Q_LINK; } break;
case 56:
# line 218 "grammar.y"
{ yyval.i = Q_IP; } break;
case 57:
# line 219 "grammar.y"
{ yyval.i = Q_ARP; } break;
case 58:
# line 220 "grammar.y"
{ yyval.i = Q_RARP; } break;
case 59:
# line 221 "grammar.y"
{ yyval.i = Q_TCP; } break;
case 60:
# line 222 "grammar.y"
{ yyval.i = Q_UDP; } break;
case 61:
# line 223 "grammar.y"
{ yyval.i = Q_ICMP; } break;
case 62:
# line 224 "grammar.y"
{ yyval.i = Q_DECNET; } break;
case 63:
# line 225 "grammar.y"
{ yyval.i = Q_LAT; } break;
case 64:
# line 226 "grammar.y"
{ yyval.i = Q_MOPDL; } break;
case 65:
# line 227 "grammar.y"
{ yyval.i = Q_MOPRC; } break;
case 66:
# line 229 "grammar.y"
{ yyval.rblk = gen_broadcast(yypvt[-1].i); } break;
case 67:
# line 230 "grammar.y"
{ yyval.rblk = gen_multicast(yypvt[-1].i); } break;
case 68:
# line 231 "grammar.y"
{ yyval.rblk = gen_less(yypvt[-0].i); } break;
case 69:
# line 232 "grammar.y"
{ yyval.rblk = gen_greater(yypvt[-0].i); } break;
case 70:
# line 233 "grammar.y"
{ yyval.rblk = gen_byteop(yypvt[-1].i, yypvt[-2].i, yypvt[-0].i); } break;
case 71:
# line 234 "grammar.y"
{ yyval.rblk = gen_inbound(0); } break;
case 72:
# line 235 "grammar.y"
{ yyval.rblk = gen_inbound(1); } break;
case 73:
# line 237 "grammar.y"
{ yyval.i = BPF_JGT; } break;
case 74:
# line 238 "grammar.y"
{ yyval.i = BPF_JGE; } break;
case 75:
# line 239 "grammar.y"
{ yyval.i = BPF_JEQ; } break;
case 76:
# line 241 "grammar.y"
{ yyval.i = BPF_JGT; } break;
case 77:
# line 242 "grammar.y"
{ yyval.i = BPF_JGE; } break;
case 78:
# line 243 "grammar.y"
{ yyval.i = BPF_JEQ; } break;
case 79:
# line 245 "grammar.y"
{ yyval.a = gen_loadi(yypvt[-0].i); } break;
case 81:
# line 248 "grammar.y"
{ yyval.a = gen_load(yypvt[-3].i, yypvt[-1].a, 1); } break;
case 82:
# line 249 "grammar.y"
{ yyval.a = gen_load(yypvt[-5].i, yypvt[-3].a, yypvt[-1].i); } break;
case 83:
# line 250 "grammar.y"
{ yyval.a = gen_arth(BPF_ADD, yypvt[-2].a, yypvt[-0].a); } break;
case 84:
# line 251 "grammar.y"
{ yyval.a = gen_arth(BPF_SUB, yypvt[-2].a, yypvt[-0].a); } break;
case 85:
# line 252 "grammar.y"
{ yyval.a = gen_arth(BPF_MUL, yypvt[-2].a, yypvt[-0].a); } break;
case 86:
# line 253 "grammar.y"
{ yyval.a = gen_arth(BPF_DIV, yypvt[-2].a, yypvt[-0].a); } break;
case 87:
# line 254 "grammar.y"
{ yyval.a = gen_arth(BPF_AND, yypvt[-2].a, yypvt[-0].a); } break;
case 88:
# line 255 "grammar.y"
{ yyval.a = gen_arth(BPF_OR, yypvt[-2].a, yypvt[-0].a); } break;
case 89:
# line 256 "grammar.y"
{ yyval.a = gen_arth(BPF_LSH, yypvt[-2].a, yypvt[-0].a); } break;
case 90:
# line 257 "grammar.y"
{ yyval.a = gen_arth(BPF_RSH, yypvt[-2].a, yypvt[-0].a); } break;
case 91:
# line 258 "grammar.y"
{ yyval.a = gen_neg(yypvt[-0].a); } break;
case 92:
# line 259 "grammar.y"
{ yyval.a = yypvt[-1].a; } break;
case 93:
# line 260 "grammar.y"
{ yyval.a = gen_loadlen(); } break;
case 94:
# line 262 "grammar.y"
{ yyval.i = '&'; } break;
case 95:
# line 263 "grammar.y"
{ yyval.i = '|'; } break;
case 96:
# line 264 "grammar.y"
{ yyval.i = '<'; } break;
case 97:
# line 265 "grammar.y"
{ yyval.i = '>'; } break;
case 98:
# line 266 "grammar.y"
{ yyval.i = '='; } break;
case 100:
# line 269 "grammar.y"
{ yyval.i = yypvt[-1].i; } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

